const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const benefit_plans = sequelize.define(
    'benefit_plans',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      carrier: {
        type: DataTypes.TEXT,
      },

      plan_type: {
        type: DataTypes.ENUM,

        values: ['Medical', 'Dental', 'Vision'],
      },

      country: {
        type: DataTypes.TEXT,
      },

      currency: {
        type: DataTypes.TEXT,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  benefit_plans.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    db.benefit_plans.hasMany(db.enrollments, {
      as: 'enrollments_plan',
      foreignKey: {
        name: 'planId',
      },
      constraints: false,
    });

    //end loop

    db.benefit_plans.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });

    db.benefit_plans.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.benefit_plans.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return benefit_plans;
};
